summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Christoph Willing2021-05-19 12:19:58 +0200
committer Willy Sudiarto Raharjo2021-05-19 13:39:55 +0200
commit60996efaa10257efbc2738969f0a4421ba2ca46d (patch)
tree582036707b4551ea3c3cac33b269eded918ea6b5 /development
parent1564a3855cc1400ef18340997b1ebf6c64e98c9e (diff)
downloadslackbuilds-60996efaa10257efbc2738969f0a4421ba2ca46d.tar.gz
development/shiboken2: Added. Required for pyside2
Signed-off-by: Christoph Willing <chris.willing@linux.com> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/shiboken2/README9
-rw-r--r--development/shiboken2/shiboken2.SlackBuild102
-rw-r--r--development/shiboken2/shiboken2.info10
-rw-r--r--development/shiboken2/slack-desc19
4 files changed, 140 insertions, 0 deletions
diff --git a/development/shiboken2/README b/development/shiboken2/README
new file mode 100644
index 0000000000..b0bdb4829f
--- /dev/null
+++ b/development/shiboken2/README
@@ -0,0 +1,9 @@
+Shiboken is a fundamental piece on the Qt for Python project that serves two purposes:
+
+- Generator: Extract information from C or C++ headers and generate CPython code that
+allow to bring C or C++ projects to Python. This process uses a library called ApiExtractor
+which internally uses Clang.
+
+- Module: An utility Python module that exposed new Python types, functions to handle pointers,
+among other things, that is written in CPython and can use independently of the generator.
+
diff --git a/development/shiboken2/shiboken2.SlackBuild b/development/shiboken2/shiboken2.SlackBuild
new file mode 100644
index 0000000000..ab24590201
--- /dev/null
+++ b/development/shiboken2/shiboken2.SlackBuild
@@ -0,0 +1,102 @@
+#!/bin/sh
+
+# Slackware build script for shiboken2
+
+# Copyright 2021 Christoph Willing Brisbane, Australia
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=shiboken2
+VERSION=${VERSION:-5.15.2}
+SRCNAM=pyside-setup-opensource-src
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.xz
+cd $SRCNAM-$VERSION/sources/$PRGNAM
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ export CC=/usr/bin/clang
+ export CXX=/usr/bin/clang++
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DPYTHON_EXECUTABLE=/usr/bin/python3 \
+ -DBUILD_TESTS=ON \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING* doc \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/shiboken2/shiboken2.info b/development/shiboken2/shiboken2.info
new file mode 100644
index 0000000000..4f0a55d060
--- /dev/null
+++ b/development/shiboken2/shiboken2.info
@@ -0,0 +1,10 @@
+PRGNAM="shiboken2"
+VERSION="5.15.2"
+HOMEPAGE="https://wiki.qt.io/Qt_for_Python"
+DOWNLOAD="https://download.qt.io/official_releases/QtForPython/pyside2/PySide2-5.15.2-src/pyside-setup-opensource-src-5.15.2.tar.xz"
+MD5SUM="e9bb6b57d39eb6cf1720cd3589a8b76a"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Christoph Willing"
+EMAIL="chris.willing@linux.com"
diff --git a/development/shiboken2/slack-desc b/development/shiboken2/slack-desc
new file mode 100644
index 0000000000..cf21b46688
--- /dev/null
+++ b/development/shiboken2/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+shiboken2: shiboken2 (PySide2 bindings generator plugin)
+shiboken2:
+shiboken2: The Shiboken Generator is the plugin that creates the PySide bindings
+shiboken2: source files from Qt headers and auxiliary files (typesystems,
+shiboken2: global.h and glue files).
+shiboken2:
+shiboken2:
+shiboken2:
+shiboken2:
+shiboken2:
+shiboken2: